searchNodes=[{"doc":"An Ecto type for Predicator insturctions.","ref":"Ecto.PredicatorInstructions.html","title":"Ecto.PredicatorInstructions","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1.","ref":"Ecto.PredicatorInstructions.html#cast/1","title":"Ecto.PredicatorInstructions.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1.","ref":"Ecto.PredicatorInstructions.html#dump/1","title":"Ecto.PredicatorInstructions.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"Ecto.PredicatorInstructions.html#embed_as/1","title":"Ecto.PredicatorInstructions.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"Ecto.PredicatorInstructions.html#equal?/2","title":"Ecto.PredicatorInstructions.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1.","ref":"Ecto.PredicatorInstructions.html#load/1","title":"Ecto.PredicatorInstructions.load/1","type":"function"},{"doc":"The underlying schema type.","ref":"Ecto.PredicatorInstructions.html#type/0","title":"Ecto.PredicatorInstructions.type/0","type":"function"},{"doc":"Documentation for Predicator.Lexer and Parser currently compatible with 1.1.0 predicate syntax","ref":"Predicator.html","title":"Predicator","type":"module"},{"doc":"Compiles the source string into a list of instructions.These instructions can be evaluated by a Predicator.Evaluator.Examplesiex&gt; Predicator.compile &quot;score &gt; 600 or income &gt; 9000&quot; {:ok, [ [&quot;load&quot;, &quot;score&quot;], [&quot;lit&quot;, 600], [&quot;compare&quot;, &quot;GT&quot;], [&quot;jtrue&quot;, 4], [&quot;load&quot;, &quot;income&quot;], [&quot;lit&quot;, 9000], [&quot;compare&quot;, &quot;GT&quot;] ]}","ref":"Predicator.html#compile/2","title":"Predicator.compile/2","type":"function"},{"doc":"Compiles the source string into a list of instructions.Returns the unwarpped compiled instructions, or raises if an error occurs. These instructions can be evaluated by a Predicator.Evaluator.Examplesiex&gt; Predicator.compile! &quot;score &gt; 600 or income &gt; 9000&quot; [ [&quot;load&quot;, &quot;score&quot;], [&quot;lit&quot;, 600], [&quot;compare&quot;, &quot;GT&quot;], [&quot;jtrue&quot;, 4], [&quot;load&quot;, &quot;income&quot;], [&quot;lit&quot;, 9000], [&quot;compare&quot;, &quot;GT&quot;] ]","ref":"Predicator.html#compile!/2","title":"Predicator.compile!/2","type":"function"},{"doc":"Takes a predicate set, a context struct and options.Eval options:map_type: type of keys for context map, :atom or :string. Defaults to :string.nil_values: list of values considered &quot;blank&quot; for isblank comparison. Defaults to [&quot;&quot;, nil].","ref":"Predicator.html#eval/3","title":"Predicator.eval/3","type":"function"},{"doc":"Compiles the source into instructions, which are then evaluated, along with the provided context to return a boolean.Options::map_type: type of keys for context map, :atom or :string. Defaults to :string.:nil_values: list of values considered &quot;blank&quot; for isblank comparison. Defaults to [&quot;&quot;, nil].Examplesiex&gt; Predicator.evaluate &quot;score &gt; 600&quot;, %{&quot;score&quot; =&gt; 590} {:ok, false} iex&gt; Predicator.evaluate &quot;score &gt; 600&quot;, %{&quot;score&quot; =&gt; 610} {:ok, true}","ref":"Predicator.html#evaluate/3","title":"Predicator.evaluate/3","type":"function"},{"doc":"Compiles the source into instructions, which are then evaluated, along with the provided context to return a boolean.Returns the unwarpped boolean, or raises if an error occurs.Options::map_type: type of keys for context map, :atom or :string. Defaults to :string.:nil_values: list of values considered &quot;blank&quot; for isblank comparison. Defaults to [&quot;&quot;, nil].Examplesiex&gt; Predicator.evaluate! &quot;score &gt; 600&quot;, %{&quot;score&quot; =&gt; 590} false iex&gt; Predicator.evaluate! &quot;score &gt; 600&quot;, %{&quot;score&quot; =&gt; 610} true","ref":"Predicator.html#evaluate!/3","title":"Predicator.evaluate!/3","type":"function"},{"doc":"Evaluates the instructions array, along with the provided context, and returns a boolean.Options::map_type: type of keys for context map, :atom or :string. Defaults to :string.:nil_values: list of values considered &quot;blank&quot; for isblank comparison. Defaults to [&quot;&quot;, nil].Examplesiex&gt; Predicator.evaluate_instructions [[&quot;load&quot;, &quot;score&quot;], [&quot;lit&quot;, 600], [&quot;compare&quot;, &quot;GT&quot;]], %{&quot;score&quot; =&gt; 590} {:ok, false} iex&gt; Predicator.evaluate_instructions [[&quot;load&quot;, &quot;score&quot;], [&quot;lit&quot;, 600], [&quot;compare&quot;, &quot;GT&quot;]], %{&quot;score&quot; =&gt; 610} {:ok, true}","ref":"Predicator.html#evaluate_instructions/3","title":"Predicator.evaluate_instructions/3","type":"function"},{"doc":"Evaluates the instructions with the context to return a boolean.Returns the unwarpped boolean, or raises if an error occurs.Options::map_type: type of keys for context map, :atom or :string. Defaults to :string.:nil_values: list of values considered &quot;blank&quot; for isblank comparison. Defaults to [&quot;&quot;, nil].Examplesiex&gt; Predicator.evaluate_instructions! [[&quot;load&quot;, &quot;score&quot;], [&quot;lit&quot;, 600], [&quot;compare&quot;, &quot;GT&quot;]], %{&quot;score&quot; =&gt; 590} false iex&gt; Predicator.evaluate_instructions! [[&quot;load&quot;, &quot;score&quot;], [&quot;lit&quot;, 600], [&quot;compare&quot;, &quot;GT&quot;]], %{&quot;score&quot; =&gt; 610} true","ref":"Predicator.html#evaluate_instructions!/3","title":"Predicator.evaluate_instructions!/3","type":"function"},{"doc":"leex_and_parse/1 takes a string or charlist and does all lexing and parsing then returns the predicate.iex&gt; leex_and_parse(&quot;13 &gt; 12&quot;) [[&quot;lit&quot;, 13], [&quot;lit&quot;, 12], [&quot;compare&quot;, &quot;GT&quot;]]iex&gt; leex_and_parse('532 == 532', :atom_key_inst) [[:lit, 532], [:lit, 532], [:compare, :EQ]]","ref":"Predicator.html#leex_and_parse/2","title":"Predicator.leex_and_parse/2","type":"function"},{"doc":"leex_string/1 takes string or charlist and returns a lexed tuple for parsing.iex&gt; leex_string('10 &gt; 5') {:ok, [{:lit, 1, 10}, {:compare, 1, :GT}, {:lit, 1, 5}], 1}iex&gt; leex_string(&quot;apple &gt; 5532&quot;) {:ok, [{:load, 1, :apple}, {:compare, 1, :GT}, {:lit, 1, 5532}], 1}","ref":"Predicator.html#leex_string/1","title":"Predicator.leex_string/1","type":"function"},{"doc":"","ref":"Predicator.html#matches?/1","title":"Predicator.matches?/1","type":"function"},{"doc":"","ref":"Predicator.html#matches?/2","title":"Predicator.matches?/2","type":"function"},{"doc":"Takes in a predicate and context and returns the match result. Context can be either a list or map. Accepts same options as eval/3.iex&gt; matches?(&quot;fruit in [&#39;apple&#39;, &#39;pear&#39;]&quot;, %{&quot;fruit&quot; =&gt; &quot;watermelon&quot;}, [map_type: :string]) false iex&gt; matches?(&quot;fruit in [&#39;apple&#39;, &#39;pear&#39;]&quot;, [fruit: &quot;pear&quot;], [map_type: :atom]) true iex&gt; matches?(&quot;fruit is blank&quot;, [fruit: nil], [map_type: :atom, nil_values: [nil]]) true","ref":"Predicator.html#matches?/3","title":"Predicator.matches?/3","type":"function"},{"doc":"parse_lexed/1 takes a leexed token(list or tup) and returns a predicate. It also can take optional atom for type of token keys to return. options are :string_ey_inst &amp; :atom_key_instiex&gt; parse_lexed({:ok, [{:load, 1, :apple}, {:compare, 1, :GT}, {:lit, 1, 5532}], 1}) {:ok, [[&quot;load&quot;, &quot;apple&quot;], [&quot;lit&quot;, 5532], [&quot;compare&quot;, &quot;GT&quot;]]} iex&gt; parse_lexed({:ok, [{:load, 1, :apple}, {:compare, 1, :GT}, {:lit, 1, 5532}], 1}, :string_key_inst) {:ok, [[&quot;load&quot;, &quot;apple&quot;], [&quot;lit&quot;, 5532], [&quot;compare&quot;, &quot;GT&quot;]]} iex&gt; parse_lexed([{:load, 1, :apple}, {:compare, 1, :GT}, {:lit, 1, 5532}], :atom_key_inst) {:ok, [[:load, :apple], [:lit, 5532], [:compare, :GT]]}","ref":"Predicator.html#parse_lexed/2","title":"Predicator.parse_lexed/2","type":"function"},{"doc":"The data map provided to predicates as they are evaluated.","ref":"Predicator.html#t:context/0","title":"Predicator.context/0","type":"type"},{"doc":"Each instruction in encoded as a list. This is a list of these lists which can be evaluated by a Predicator.Evaluator.","ref":"Predicator.html#t:instructions/0","title":"Predicator.instructions/0","type":"type"},{"doc":"","ref":"Predicator.html#t:predicate/0","title":"Predicator.predicate/0","type":"type"},{"doc":"The source code of the predicate. This will be lexed, parsed and compiled into an array of instructions which can be evaluated by a Predicator.Evaluator.","ref":"Predicator.html#t:source/0","title":"Predicator.source/0","type":"type"},{"doc":"","ref":"Predicator.html#t:token_key_t/0","title":"Predicator.token_key_t/0","type":"type"},{"doc":"Error struct returned by Date Conversion Error. iex&gt; %Predicator.DateConversionError{} %Predicator.DateConversionError{error: &quot;Date was not parsable&quot;, date: nil}","ref":"Predicator.DateConversionError.html","title":"Predicator.DateConversionError","type":"module"},{"doc":"","ref":"Predicator.DateConversionError.html#t:t/0","title":"Predicator.DateConversionError.t/0","type":"type"},{"doc":"Evaluator Module","ref":"Predicator.Evaluator.html","title":"Predicator.Evaluator","type":"module"},{"doc":"","ref":"Predicator.Evaluator.html#execute/1","title":"Predicator.Evaluator.execute/1","type":"function"},{"doc":"Execute will evaluate a predicator instruction set.If your context struct is using string_keyed map then you will need to pass in the [map_type: :string] options to the execute function to evaluate.Examples:iex&gt; Predicator.Evaluator.execute([[&quot;lit&quot;, true]]) trueiex&gt; Predicator.Evaluator.execute([[&quot;lit&quot;, 2], [&quot;lit&quot;, 3], [&quot;compare&quot;, &quot;LT&quot;]]) trueiex&gt; Predicator.Evaluator.execute([[&quot;load&quot;, &quot;age&quot;], [&quot;lit&quot;, 18], [&quot;compare&quot;, &quot;GT&quot;]], %{age: 19}) trueiex&gt; Predicator.Evaluator.execute([[&quot;load&quot;, &quot;name&quot;], [&quot;lit&quot;, &quot;jrichocean&quot;], [&quot;compare&quot;, &quot;EQ&quot;]], %{age: 19}) {:error, %Predicator.ValueError{error: &quot;Non valid load value to evaluate&quot;, instruction_pointer: 0, instructions: [[&quot;load&quot;, &quot;name&quot;], [&quot;lit&quot;, &quot;jrichocean&quot;], [&quot;compare&quot;, &quot;EQ&quot;]], stack: [], opts: [map_type: :string, nil_values: [&quot;&quot;, nil]]}}iex&gt; Predicator.Evaluator.execute([[&quot;load&quot;, &quot;age&quot;], [&quot;lit&quot;, 18], [&quot;compare&quot;, &quot;GT&quot;]], %{&quot;age&quot; =&gt; 19}, [map_type: :string]) true","ref":"Predicator.Evaluator.html#execute/3","title":"Predicator.Evaluator.execute/3","type":"function"},{"doc":"","ref":"Predicator.Evaluator.html#to_machine/3","title":"Predicator.Evaluator.to_machine/3","type":"function"},{"doc":"Error types returned from Predicator.Evaluator","ref":"Predicator.Evaluator.html#t:error_t/0","title":"Predicator.Evaluator.error_t/0","type":"type"},{"doc":"Error struct returned by Value Error Types. iex&gt; %Predicator.InstructionError{} %Predicator.InstructionError{error: &quot;Non valid predicate instruction&quot;, instructions: nil, predicate: nil, instruction_pointer: nil, stack: nil}","ref":"Predicator.InstructionError.html","title":"Predicator.InstructionError","type":"module"},{"doc":"","ref":"Predicator.InstructionError.html#instruction_error/2","title":"Predicator.InstructionError.instruction_error/2","type":"function"},{"doc":"","ref":"Predicator.InstructionError.html#t:t/0","title":"Predicator.InstructionError.t/0","type":"type"},{"doc":"Error struct returned by Instruction Not Complete Error. iex&gt; %Predicator.InstructionNotCompleteError{} %Predicator.InstructionNotCompleteError{error: &quot;Instruction must have evaluation rule after a type conversion&quot;, instructions: nil, stack: nil, instruction_pointer: nil}","ref":"Predicator.InstructionNotCompleteError.html","title":"Predicator.InstructionNotCompleteError","type":"module"},{"doc":"","ref":"Predicator.InstructionNotCompleteError.html#inst_not_complete_error/1","title":"Predicator.InstructionNotCompleteError.inst_not_complete_error/1","type":"function"},{"doc":"","ref":"Predicator.InstructionNotCompleteError.html#t:t/0","title":"Predicator.InstructionNotCompleteError.t/0","type":"type"},{"doc":"A Machine Struct is comprised of the instructions set, the current stack, the instruction pointer and the context struct. iex&gt;%Predicator.Machine{} %Predicator.Machine{instructions: [], stack: [], instruction_pointer: 0, context: nil, opts: []}","ref":"Predicator.Machine.html","title":"Predicator.Machine","type":"module"},{"doc":"","ref":"Predicator.Machine.html#accept_instruction/2","title":"Predicator.Machine.accept_instruction/2","type":"function"},{"doc":"","ref":"Predicator.Machine.html#complete?/1","title":"Predicator.Machine.complete?/1","type":"function"},{"doc":"","ref":"Predicator.Machine.html#has_variable?/2","title":"Predicator.Machine.has_variable?/2","type":"function"},{"doc":"","ref":"Predicator.Machine.html#increment_pointer/2","title":"Predicator.Machine.increment_pointer/2","type":"function"},{"doc":"","ref":"Predicator.Machine.html#load!/2","title":"Predicator.Machine.load!/2","type":"function"},{"doc":"","ref":"Predicator.Machine.html#new/3","title":"Predicator.Machine.new/3","type":"function"},{"doc":"","ref":"Predicator.Machine.html#next_instruction/1","title":"Predicator.Machine.next_instruction/1","type":"function"},{"doc":"","ref":"Predicator.Machine.html#peek/1","title":"Predicator.Machine.peek/1","type":"function"},{"doc":"","ref":"Predicator.Machine.html#pop_instruction/1","title":"Predicator.Machine.pop_instruction/1","type":"function"},{"doc":"","ref":"Predicator.Machine.html#put_instruction/3","title":"Predicator.Machine.put_instruction/3","type":"function"},{"doc":"","ref":"Predicator.Machine.html#replace_stack/2","title":"Predicator.Machine.replace_stack/2","type":"function"},{"doc":"","ref":"Predicator.Machine.html#step/1","title":"Predicator.Machine.step/1","type":"function"},{"doc":"","ref":"Predicator.Machine.html#t:t/0","title":"Predicator.Machine.t/0","type":"type"},{"doc":"Error struct returned by Value Error Types. iex&gt; %Predicator.ValueError{} %Predicator.ValueError{error: &quot;Non valid load value to evaluate&quot;, instructions: nil, stack: nil, instruction_pointer: nil}","ref":"Predicator.ValueError.html","title":"Predicator.ValueError","type":"module"},{"doc":"","ref":"Predicator.ValueError.html#value_error/1","title":"Predicator.ValueError.value_error/1","type":"function"},{"doc":"","ref":"Predicator.ValueError.html#t:t/0","title":"Predicator.ValueError.t/0","type":"type"},{"doc":"PredicatorPredicator is a secure, non-evaling condition (boolean predicate) engine for end users.It turns a string like &quot;score &gt; 600 or income &gt; 9000&quot; along with a supplied context into a true or false.This condition can be stored as an attribute of a model (ex: an Offer model could store a condition indicating if it is available to a customer).","ref":"readme.html","title":"Predicator","type":"extras"},{"doc":"CompilationThe source code can be compiled down to list of instructions.Predicator.compile! &quot;score &gt; 600 or income &gt; 9000&quot; # [ # [&quot;load&quot;, &quot;score&quot;], # [&quot;lit&quot;, 600], # [&quot;compare&quot;, &quot;GT&quot;], # [&quot;jtrue&quot;, 4], # [&quot;load&quot;, &quot;income&quot;], # [&quot;lit&quot;, 9000], # [&quot;compare&quot;, &quot;GT&quot;] # ]EvaluatingThese instructions can be executed with a Predicator Evaluator in any available language (currently Elixir, and Ruby with others in progress).Predicator.compile!(&quot;score &gt; 600 or income &gt; 9000&quot;) |&gt; Predicator.evaluate_instructions!( %{&quot;score&quot; =&gt; 590, &quot;income&quot; =&gt; &quot;6000&quot;} ) # false Predicator.compile!(&quot;score &gt; 600 or income &gt; 9000&quot;) |&gt; Predicator.evaluate_instructions!( %{&quot;score&quot; =&gt; 590, &quot;income&quot; =&gt; &quot;9500&quot;} ) # trueIt is also possible to combine these steps:Predicator.evaluate!(&quot;score &gt; 600 or income &gt; 9000&quot;, %{&quot;score&quot; =&gt; 590, &quot;income&quot; =&gt; &quot;7500&quot;}) # false Predicator.evaluate!(&quot;score &gt; 600 or income &gt; 9000&quot;, %{&quot;score&quot; =&gt; 590, &quot;income&quot; =&gt; &quot;9500&quot;}) # true","ref":"readme.html#usage","title":"Predicator - Usage","type":"extras"},{"doc":"The package can be installed by:Adding to your list of dependencies in mix.exs: def deps do [{:predicator, &quot;~&gt; 0.9&quot;}] end or if you want to use the ecto types for predicator you can add the predicator_ecto lib. def deps do [ {:predicator, &quot;~&gt; 0.9&quot;}, {:predicator_ecto, &quot;&gt;= 0.0.0&quot;}, ] endTODO:[ ] Lex and parse parens[ ] Lex and parse date, duration, ago, fromnow","ref":"readme.html#installation","title":"Predicator - Installation","type":"extras"}]